local RayUI, E, L, V, P, G = unpack(select(2, ...))
local MER = ElvUI_MerathilisUI[1]
local MERL = MER:GetModule("MER_Layout")
local module = RayUI:NewModule("RayUILayout", "AceHook-3.0", "AceEvent-3.0")
local AB = E:GetModule("ActionBars")
local CH = E:GetModule("Chat")
local DT = E:GetModule("DataTexts")
local LO = E:GetModule("Layout")
local DB = E:GetModule("DataBars")

local _G = _G
local InCombatLockdown = InCombatLockdown
local PlaySound = PlaySound
local SOUNDKIT = SOUNDKIT

local function ChangeButtonState()
	if _G.MerathilisUIButton1 then
		if E.db.actionbar.bar4.enabled == true then
			_G.MerathilisUIButton1.tex:SetTexture([[Interface\AddOns\ElvUI\media\textures\MinusButton.blp]])
		else
			_G.MerathilisUIButton1.tex:SetTexture([[Interface\AddOns\ElvUI\media\textures\PlusButton.blp]])
		end
	end

	if _G.MerathilisUIButton2 then
		if E.db.actionbar.bar5.enabled == true then
			_G.MerathilisUIButton2.tex:SetTexture([[Interface\AddOns\ElvUI\media\textures\MinusButton.blp]])
		else
			_G.MerathilisUIButton2.tex:SetTexture([[Interface\AddOns\ElvUI\media\textures\PlusButton.blp]])
		end
	end
end

local function ToggleActionBar(id)
	if InCombatLockdown() then RayUI:Print(_G.ERR_NOT_IN_COMBAT) return end
	if E.db.actionbar["bar"..id].enabled == true then
		E.db.actionbar["bar"..id].enabled = false
	elseif E.db.actionbar["bar"..id].enabled == false then
		E.db.actionbar["bar"..id].enabled = true
	end
	AB:UpdateButtonSettings("bar"..id)
	ChangeButtonState()
end

function module:Initialize()
	if E.db.mui.general.panels ~= true then return end

	if _G.MerathilisUIButton1 then
		ChangeButtonState(_G.MerathilisUIButton1)
		_G.MerathilisUIButton1:SetScript("OnClick", function(self, btn)
			if btn == "LeftButton" then
				ToggleActionBar(4)
				PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_OFF)
			elseif btn == "RightButton" then
				-- ToggleActionBar(3)
				E.db.databars.reputation.enable = not E.db.databars.reputation.enable
				DB:EnableDisable_ReputationBar()
				E.db.databars.azerite.enable = E.db.databars.reputation.enable
				DB:EnableDisable_AzeriteBar()
				E.db.mui.datatexts.middle.enable = E.db.databars.reputation.enable
				MERL:MiddleDatatextLayout()
				PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_OFF)
			end
		end)
	end
	if _G.MerathilisUIButton2 then
		ChangeButtonState(_G.MerathilisUIButton2)
		_G.MerathilisUIButton2:SetScript("OnClick", function(self, btn)
			if btn == "LeftButton" then
				ToggleActionBar(5)
				PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_OFF)
			elseif btn == "RightButton" then
				-- ToggleActionBar(3)
				E.db.databars.reputation.enable = not E.db.databars.reputation.enable
				DB:EnableDisable_ReputationBar()
				E.db.databars.azerite.enable = E.db.databars.reputation.enable
				DB:EnableDisable_AzeriteBar()
				E.db.mui.datatexts.middle.enable = E.db.databars.reputation.enable
				MERL:MiddleDatatextLayout()
				PlaySound(SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_OFF)
			end
		end)
	end
end

RayUI:RegisterModule(module:GetName())
